#!/bin/sh
# Run
set -e

DIR=../../result
export F_UFMTENDIAN=big

# Initial date
IYYYY=1982
IMM=01
IDD=01
IHH=00

# Final date
EYYYY=1982
EMM=01
EDD=10
EHH=00
# 1111 for p-level output
FORT2=1111

cat ../../model/update/cls_instep.h

echo 'OK to continue? (y/n)'
read CONT
if test ! $CONT = y
then
  echo 'STOP'
  exit
fi
#
# SPEEDY
#
TMPDIR=../../model/tmp

mkdir -p $TMPDIR
rm -f $TMPDIR/*

cd $TMPDIR
#
# BUILD SPEEDY MODEL
#
echo '>>>BEGIN BUILDING SPEEDY MODEL'
cp ../../model/source/makefile ./
cp ../../model/source/*.h ./
cp ../../model/source/*.f ./
cp ../../model/source/*.s ./

mv par_horres_t30.h atparam.h
mv par_verres.h atparam1.h

cp ../../model/ver32.input/cls_*.h ./
cp ../../model/ver32.input/inpfiles.s ./

cp ../../model/update/*.h ./
cp ../../model/update/*.f ./
cp ../../model/update/makefile ./

make imp.exe

sh inpfiles.s t30

echo '>>>END BUILDING SPEEDY MODEL'
#
# MAIN LOOP
#
while test $IYYYY$IMM$IDD$IHH -le $EYYYY$EMM$EDD$EHH
do

echo ">>>BEGIN COMPUTATION OF $IYYYY/$IMM/$IDD/$IHH"

cd $TMPDIR

echo $FORT2 > fort.2
echo $IYYYY >> fort.2
echo $IMM >> fort.2
echo $IDD >> fort.2
echo $IHH >> fort.2

ln -fs $DIR/$IYYYY$IMM$IDD$IHH.grd fort.90
time ./imp.exe > out.lis
#
# Outputs
#
mv *.grd $DIR/
mv out.lis $DIR/

# Increment date
IHH=`expr $IHH + 6`
if test $IHH -lt 10
then
  IHH=0$IHH
elif test $IHH -gt 23
then
  IHH=00
  IDD=`expr $IDD + 1`
  if test $IDD -lt 10
  then
    IDD=0$IDD
  elif test $IDD -eq 29
  then
    ITMP=`expr $IYYYY % 4`
    if test $IMM -eq 02 -a $ITMP -ne 0
    then
      IDD=01
      IMM=03
    fi
  elif test $IDD -eq 30
  then
    ITMP=`expr $IYYYY % 4`
    if test $IMM -eq 02 -a $ITMP -eq 0
    then
      IDD=01
      IMM=03
    fi
  elif test $IDD -eq 31
  then
    if test $IMM -eq 04 -o $IMM -eq 06
    then
      IDD=01
      IMM=`expr $IMM + 1`
      IMM=0$IMM
    elif test $IMM -eq 09 -o $IMM -eq 11
    then
      IDD=01
      IMM=`expr $IMM + 1`
    fi
  elif test $IDD -eq 32
  then
    IDD=01
    IMM=`expr $IMM + 1`
    if test $IMM -lt 10
    then
      IMM=0$IMM
    fi
  fi
  if test $IMM -gt 12
  then
    IMM=01
    IYYYY=`expr $IYYYY + 1`
  fi
fi

done

echo "NORMAL END"

